# Assignment 1 Present Value Calculator KEY
# 
# Unstable for some reason!
# while (!is.null(dev.list()))  dev.off() # Clear old plots
rm(list = ls())  # Take out the Environment "trash"
cat("\014") # Clear Console, making error checking easier.
par(family = 'Times New Roman') # Globally set fonts for graphs
# Inputs:
#  NAmt - notional amount (future value at maturity)
#  R - rate in percent
#  M - maturity, in fraction of years
#  Freq - number of compounding periods per year 
#  Method - DC - discrete compounding, CC - Continuous compounding
# Outputs:
#  Present value
#
PV <- function(NAmt, R, M, Freq, Method){
  if(Method == 'DC'){
    PresentValue <- NAmt*(1 + (R/100)/Freq)^(-M*Freq)
  } else {
    PresentValue <- NAmt*exp(-(R/100)*M)
  }
  return(PresentValue)
}
#
# Illustration 1: Single example
#
Compounding = 'DC'
Par <- 1000
Rate <- 5.0
Maturity <- 10
NPPY <- 4.0
PresentValue <- PV(Par, Rate, Maturity, NPPY, Compounding)
PresentValue
#
# Illustration 2: Single vector
#
Compounding = 'DC'
Par <- 1000
Rate <- 5.0
Maturity <- 10
NPPY <- seq(1,100,1)
PresentValue <- PV(Par, Rate, Maturity, NPPY, Compounding)
plot(NPPY, PresentValue)
#
# Illustration 3: Single vector, continuous compounding comparison
#
Compounding = 'DC'
Par <- 1000
Rate <- 5.0
Maturity <- 10
NPPY <- seq(1,100,1)
PresentValue <- PV(Par, Rate, Maturity, NPPY, Compounding)
Compounding = 'CC'
PresentValueCC <- PV(Par, Rate, Maturity, NPPY, Compounding)
plot(NPPY, PresentValue - PresentValueCC, type = 'l')
#
# Illustration 4: Two vectors, continuous compounding comparison
#
Par <- 1000
Rate <- seq(0, 10.0, 0.5)
Maturity <- seq(0, 100.0, 5)
NPPY <- 1
LRate <- length(Rate)
LMaturity <- length(Maturity)
Rate <- matrix(data = Rate, nrow = 1, ncol = LRate)
Maturity <- matrix(data = Maturity, nrow = 1, ncol = LMaturity)
Difference <- matrix(data = NA, nrow = LRate, ncol = LMaturity)
MaxYValue = 20.0
MinYValue = 0.0
ylim1 = c(1:2); ylim1[1] = MinYValue; ylim1[2] = MaxYValue
yTitle <- "Rate Difference (DC - CC)"
for(i in seq(1, LMaturity, 1)){
  Compounding = 'DC'
  PresentValue <- PV(Par, Rate, Maturity[i], NPPY, Compounding)
  Compounding = 'CC'
  PresentValueCC <- PV(Par, Rate, Maturity[i], NPPY, Compounding)
  Difference[i,] <- (PresentValue - PresentValueCC)
  plot(Maturity, Difference[i,], type = 'b', 
    main = paste0('Rate Difference: Rate = ', Rate[i], '%'),
    ylim = ylim1, ylab = yTitle)
}
# while (!is.null(dev.list()))  dev.off() # Clear old plots
for(j in seq(1, LRate, 1)){
  plot(Rate, Difference[,j], type = 'b', 
       main = paste0('Rate Difference: Maturity = ', Maturity[j], ' Years'),
       ylim = ylim1, ylab = yTitle)
}
#
# Illustration 5: 3D plot
#
library("plot3D")
x1 <- Rate
x2 <- Maturity
M <- mesh(x1, x2) # Creates a rectangular full 2-D or 3-D grid
M
x3 <- M$x + 0*M$y
y3 <- 0*M$x + M$y
z3 <- Difference
head(x3, 5)
head(y3, 5)
head(z3, 5)
mTitle1 <- "Rate Difference (DC - CC)"
phi1 <- 45 #45 # Vertical orientation (horizon to top)
theta1 <- 45 #45 # Horizontal orientation (left to right)
MaxXValue = max(x3)
MinXValue = min(x3)
xlim1 = c(1:2); xlim1[1] = MinXValue; xlim1[2] = MaxXValue
MaxYValue = max(y3)
MinYValue = min(y3)
ylim1 = c(1:2); ylim1[1] = MinYValue; ylim1[2] = MaxYValue
MaxZValue = max(z3)
MinZValue = min(z3)
zlim1 = c(1:2); zlim1[1] = MinZValue; zlim1[2] = MaxZValue
xTitle <- "Rate"
yTitle <- "Maturity"
zTitle <- "Rate Difference"
surf3D(x = x3, y = y3, z = z3, colkey = FALSE, bty = "b2", main = mTitle1,
  phi = phi1, theta = theta1, xlim = xlim1, ylim = ylim1, zlim = zlim1,
  xlab = xTitle, ylab = yTitle, zlab = zTitle, axes = TRUE, scale=TRUE,
  box=TRUE)

